/*

Copyright (C) 2016,2017 wallzero 2016,2017

This program is free software: you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free Software Foundation,
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this
program. If not, see <http://www.gnu.org/licenses/>.

*/

/*
  eslint-disable
  no-process-env,
  no-undef,
  max-nested-callbacks,
  global-require,
  import/no-commonjs,
  import/unambiguous,
  filenames/match-regex,
  prefer-arrow-callback,
  promise/prefer-await-to-then,
  promise/always-return
*/

const supertest = require('supertest');
const express = require('express');

describe('App', () => {
  let app;

  beforeAll(() => {
    process.env = {};
  });

  afterEach(() => {
    process.env = {};
    app = undefined;
    jest.resetModules();
  });

  describe('Vanilla', () => {
    beforeEach(() => {
      process.env.STATIC_PATH = 'public/vanilla';
      process.env.PORT = '8113';
      app = require('../dev.js')(express()).use('/', function (request, response) {
        response.send('Welcome');
      });
    });

    test('GET method response', (done) => {
      return supertest(app).get('/').then((response) => {
        expect(response.statusCode).toBe(200);
        done();
      });
    });
  });
});

/*
  eslint-enable
  no-process-env,
  no-undef,
  max-nested-callbacks,
  global-require,
  import/no-dynamic-require,
  import/no-commonjs,
  import/unambiguous,
  filenames/match-regex,
  prefer-arrow-callback,
  promise/prefer-await-to-then,
  promise/always-return
*/
