/*

Copyright (C) 2016,2017 wallzero 2016,2017

This program is free software: you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free Software Foundation,
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this
program. If not, see <http://www.gnu.org/licenses/>.

*/

/*
  eslint-disable
  import/unambiguous,
  import/no-commonjs,
  prefer-arrow-callback
*/

const path = require('path');
const express = require('express');
const {baseHref, staticPath} = require('../config');

const rootPath = staticPath.replace('/bundle', '');
const html5Routing = path.join(rootPath, 'index.html'); // eslint-disable-line id-match

module.exports = function (app) {
  app
    .set('view engine', 'html')
    .use(
      baseHref,
      express.static(
        rootPath,
        {setHeaders (response, file) {
          if (file.includes('workbox.js')) {
            response.set('Cache-Control', 'max-age=0, no-cache, no-store, must-revalidate');
            response.set('Pragma', 'no-cache');
            response.set('Expires', '0');
          } else {
            response.set('Cache-Control', 'public, max-age=31536000');
          }
        }}
      )
    ).all(

      // For HTML5 Routing
      baseHref + '*',
      function (request, response) {
        response.set('Cache-Control', 'public, max-age=31536000');
        response.sendFile(html5Routing);
      }
    );

  return app;
};

/*
  eslint-disable
  import/unambiguous,
  import/no-commonjs,
  prefer-arrow-callback
*/
