/*

Copyright (C) 2016,2017 wallzero 2016,2017

This program is free software: you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free Software Foundation,
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this
program. If not, see <http://www.gnu.org/licenses/>.

*/

/*
  eslint-disable
  import/unambiguous,
  import/no-commonjs,
  prefer-arrow-callback
*/

const fs = require('fs');
const path = require('path');
const express = require('express');
const {
  compression,
  production,
  staticPath
} = require('../config');

const rootPath = staticPath.replace('/bundle', '');

module.exports = function (app) {
  if (production && compression) {
    app
      // eslint-disable-next-line consistent-return
      .get('*.*', function (request, response, next) {
        if (/gzip/.test(request.get('Accept-Encoding'))) {
          fs.access(
            path.join(rootPath, request.path + '.gz'),
            fs.constants.R_OK,
            function (error) {
              if (error) {
                return next();
              }

              response.set('Content-Type', express.static.mime.lookup(request.path));
              response.set('Content-Encoding', 'gzip');

              const query = request.url.lastIndexOf('?');

              request.url = request.url.slice(0, query > -1 ? query : undefined) + '.gz';

              return next();
            }
          );
        } else {
          return next();
        }
      });
  }

  return app;
};

/*
  eslint-disable
  import/unambiguous,
  import/no-commonjs,
  prefer-arrow-callback
*/
