/*

Copyright (C) 2016,2017 wallzero 2016,2017

This program is free software: you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free Software Foundation,
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this
program. If not, see <http://www.gnu.org/licenses/>.

*/

/*
  eslint-disable
  import/unambiguous,
  import/no-commonjs,
  import/no-dynamic-require,
  no-process-env
*/

const babelJest = require('babel-jest');
const tsc = require('typescript');
const {config: configPath, tsconfig: tsconfigPath} = require('../config');
const sharedTsConfig = require('../typescript/tsconfig.json');
const babelPrep = require('./babelPrep');

const config = require(configPath);
const localTsConfig = require(tsconfigPath);

const compilerOptions = Object.assign(
  {},
  sharedTsConfig.compilerOptions,
  localTsConfig.compilerOptions
);

const babelConfig = babelPrep(config, '/\\.ts$/');
const babelTransformer = babelJest.createTransformer(babelConfig);

/* Doesn't work but should */
/*
const tsJest = require('ts-jest/preprocessor');
const jestConfig = require('../jest.test.config.json');
module.exports = {
  process (src, path) {
    return babelJest.createTransformer(babelConfig).process(
      tsJest.process(
        src,
        path,
        jestConfig
      ),
      path.substr(0, path.lastIndexOf('.')) + '.js' || path
    );
  }
};
/**/

module.exports = {
  process (source, sourcePath, ...rest) {
    return babelTransformer.process(
      tsc.transpileModule(
        source,
        {
          compilerOptions,
          fileName: sourcePath
        }
      ).outputText,
      sourcePath.substr(0, sourcePath.lastIndexOf('.')) + '.js' || sourcePath,
      ...rest
    );
  }
};

/*
  eslint-enable
  import/unambiguous,
  import/no-commonjs,
  import/no-dynamic-require,
  no-process-env
*/
