/*

Copyright (C) 2016,2017 wallzero 2016,2017

This program is free software: you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free Software Foundation,
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this
program. If not, see <http://www.gnu.org/licenses/>.

*/

/*
  eslint-disable
  global-require,
  no-process-env,
  no-undefined,
  no-nested-ternary,
  complexity,
  import/no-commonjs,
  import/unambiguous,
  import/no-dynamic-require,
  import/max-dependencies,
  filenames/match-regex
*/

const fs = require('fs');
const path = require('path');
const rimraf = require('rimraf');
const seleniumStandAlone = require('selenium-standalone');
const {
  binPath,
  chromeDriverVersion,
  geckoDriverVersion,
  ieDriverVersion,
  seleniumPath,
  seleniumVersion
} = require('./vars.conf');

fs.stat(seleniumPath, (err, stat) => { // eslint-disable-line promise/prefer-await-to-callbacks
  if (err || !stat || stat.size < 1) {
    rimraf(path.join(binPath, 'chromedriver'), (rmerr) => {
      if (rmerr) {
        throw new Error(rmerr);
      }

      seleniumStandAlone.install({
        basePath: binPath,
        baseURL: 'https://selenium-release.storage.googleapis.com',
        drivers: {
          chrome: {
            arch: process.arch,
            baseURL: 'https://chromedriver.storage.googleapis.com',
            version: chromeDriverVersion
          },
          firefox: {
            arch: process.arch,
            baseURL: 'https://github.com/mozilla/geckodriver/releases/download',
            version: geckoDriverVersion
          },
          ie: {
            arch: process.arch,
            baseURL: 'https://selenium-release.storage.googleapis.com',
            version: ieDriverVersion
          }
        },
        logger () {},
        progressCb () {},
        version: seleniumVersion
      }, (error) => {
        if (error) {
          throw new Error(error);
        }

        console.log(' \u001B[32m✔\u001B[0m Drivers downloaded to:', binPath); // eslint-disable-line no-console
      });
    });
  }
});

/*
  eslint-enable
  global-require,
  no-process-env,
  no-undefined,
  no-nested-ternary,
  complexity,
  import/no-commonjs,
  import/unambiguous,
  import/no-dynamic-require,
  import/max-dependencies,
  filenames/match-regex
*/
