/*

Copyright (C) 2016,2017 wallzero 2016,2017

This program is free software: you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free Software Foundation,
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this
program. If not, see <http://www.gnu.org/licenses/>.

*/

/*
  eslint-disable
  import/unambiguous,
  import/no-commonjs,
  no-process-env,
  complexity
*/

const path = require('path');
const fileExists = require('file-exists');
const directoryExists = require('directory-exists');

const SRC_PATH = process.env.SRC_PATH || '.';

module.exports = function resolve (name, full) {
  if (full) {
    if (fileExists.sync(path.join(process.cwd(), full))) {
      return path.resolve(path.join(process.cwd(), full));
    } else if (fileExists.sync(path.join(full))) {
      return path.resolve(path.join(full));
    } else {
      return false;
    }
  } else if (fileExists.sync(path.join(process.cwd(), SRC_PATH, name))) {
    return path.resolve(path.join(process.cwd(), SRC_PATH, name));
  } else if (fileExists.sync(path.join(process.cwd(), name))) {
    return path.resolve(path.join(process.cwd(), name));
  } else if (fileExists.sync(process.cwd())) {
    return path.resolve(process.cwd());
  } else if (fileExists.sync(path.join(__dirname, name))) {
    return path.resolve(path.join(__dirname, name));
  } else if (fileExists.sync(path.join(__dirname, 'postcss', name))) {
    return path.resolve(path.join(__dirname, 'postcss', name));
  } else if (fileExists.sync(path.join(__dirname, 'typescript', name))) {
    return path.resolve(path.join(__dirname, 'typescript', name));
  } else if (fileExists.sync(path.join(__dirname, 'lint', name))) {
    return path.resolve(path.join(__dirname, 'lint', name));
  } else if (fileExists.sync(path.join(__dirname, 'jest', name))) {
    return path.resolve(path.join(__dirname, 'jest', name));
  } else if (directoryExists.sync(path.join(process.cwd(), 'node_modules', name))) {
    return path.join(process.cwd(), 'node_modules', name);
  } else {
    return false;
  }
};

/*
  eslint-enable
  import/unambiguous,
  import/no-commonjs,
  no-process-env,
  complexity
*/
